unit tools;

interface

type
  int = longint;

const
  MAX = 2000;

var
  i, len: int;
  a: array[0..MAX, 0..MAX + 1] of extended;

function randsymb(const s: string): char;
function insert(const s: string; n: int; const sym: string): string;
function genrand(leng: int): string;
function genrandbal(leng, bal: int): string;
procedure init(maxlen, rnd: int);

implementation

function aa(i, j: int): extended;
begin
  result := a[i, j] * a[len - i, j];
end;

function randsymb(const s: string): char;
begin
  result := s[random(length(s)) + 1];
end;

function insert(const s: string; n: int; const sym: string): string;
var
  i, j: int;
begin
  result := s;
  for i := 1 to n do
  begin
    j := random(length(result));
    result := copy(result, 1, j) + randsymb(sym) + copy(result, j + 1, length(result) - j);
  end;
end;

function genrand(leng: int): string;
var
  i, j: int;
begin
  len := leng;
  SetLength(result, len);
  j := 0;
  for i := 1 to len do
  begin
    if (random * (aa(i, j + 1) + aa(i, j - 1)) < aa(i, j + 1)) then
    begin
      result[i] := '(';
      inc(j);
    end
    else
    begin
      result[i] := ')';
      dec(j);
    end;
  end;
end;

function genrandbal(leng, bal: int): string;
var
  i, j: int;
begin
  inc(bal, (leng + bal) mod 2);
  result := genrand(leng - abs(bal));
  for i := 1 to bal do
  begin
    j := random(length(result));
    result := copy(result, 1, j) + '(' + copy(result, j + 1, length(result) - j);
  end;
  for i := 1 to -bal do
  begin
    j := random(length(result));
    result := copy(result, 1, j) + ')' + copy(result, j + 1, length(result) - j);
  end;
end;

procedure init(maxlen, rnd: int);
var
  i, j: int;
begin
  randseed := maxlen * maxlen - rnd * rnd * rnd;
  a[0, 0] := 1;
  for i := 1 to maxlen do
  begin
    for j := 0 to i do
    begin
      a[i, j] := a[i - 1, j + 1];
      if (j > 0) then
        a[i, j] := a[i, j] + a[i - 1, j - 1];
    end;
  end;
end;

end.
